## graphviz 2.42.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8 FATAL_ERROR)
project (Graphviz)

include(FeatureSummary)

# =============================== Build options ================================
option(enable_ltdl     "Support on-demand plugin loading" ON)
option(with_digcola    "DIGCOLA features in neato layout engine" ON )
option(with_ipsepcola  "IPSEPCOLA features in neato layout engine (disabled by default - C++ portability issues)." OFF )
option(with_ortho      "ORTHO features in neato layout engine." ON )
option(with_sfdp       "sfdp layout engine." ON )
option(with_smyrna     "SMYRNA large graph viewer (disabled by default - experimental)" OFF)

if (enable_ltdl)
        add_definitions(-DENABLE_LTDL)
endif (enable_ltdl)

if (with_digcola)
    add_definitions(-DDIGCOLA)
endif (with_digcola)

if (with_ipsepcola)
    add_definitions(-DIPSEPCOLA)
endif (with_ipsepcola)

if (with_ortho)
    add_definitions(-DORTHO)
endif (with_ortho)

if (with_sfdp)
    add_definitions(-DSFDP)
endif (with_sfdp)

if (with_smyrna)
    # TODO include dependency checks
    add_definitions(-DSMYRNA)
endif (with_smyrna)

# ===================== Append local CMake module directory ====================
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# ============================= Build dependencies =============================
find_package(AWK REQUIRED)
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)
find_package(Git REQUIRED)
find_package(Perl REQUIRED)

# ================== Convenient values for CMake configuration =================
set(BINARY_INSTALL_DIR      bin)
set(LIBRARY_INSTALL_DIR     lib)
set(PLUGIN_INSTALL_DIR      ${LIBRARY_INSTALL_DIR}/graphviz)
set(HEADER_INSTALL_DIR      include/graphviz)
set(MAN_INSTALL_DIR         share/man/man3)
# TODO: Find a way to check for groff and ps2pdf for manpage pdf generation
# set(MAN_PDF_INSTALL_DIR share/graphviz/doc/pdf)
set(TOP_SOURCE_DIR          "${CMAKE_SOURCE_DIR}")
set(TOP_BINARY_DIR          "${CMAKE_CURRENT_BINARY_DIR}")
set(GRAPHVIZ_LIB_DIR        "${CMAKE_CURRENT_SOURCE_DIR}/lib")
set(WINDOWS_DEPENDENCY_DIR  "${CMAKE_CURRENT_SOURCE_DIR}/windows/dependencies/libraries")
if (CMAKE_CL_64)
    set(WINDOWS_DEPENDENCY_DIR "${WINDOWS_DEPENDENCY_DIR}/x64")
else()
    set(WINDOWS_DEPENDENCY_DIR "${WINDOWS_DEPENDENCY_DIR}/x86")
endif()

set(GRAPHVIZ_PLUGIN_VERSION 6)
# Name of the config file used by Graphviz
set(GVPLUGIN_CONFIG_FILE config${GRAPHVIZ_PLUGIN_VERSION})

# ============================ Library dependencies ============================
if (WIN32)
    list(APPEND CMAKE_LIBRARY_PATH ${WINDOWS_DEPENDENCY_DIR}/lib)
    list(APPEND CMAKE_INCLUDE_PATH ${WINDOWS_DEPENDENCY_DIR}/include ${WINDOWS_DEPENDENCY_DIR}/bin)
else()
    list(APPEND CMAKE_INCLUDE_PATH /usr/lib /usr/local/lib /usr/lib/x86_64-linux-gnu)
endif()

find_package(ANN)
find_package(Cairo)
find_package(EXPAT)
find_package(GD)
find_package(LTDL)
find_package(PangoCairo)
find_package(ZLIB)

if (WIN32)
    # Find Windows specific dependencies
    find_package(RxSpencer REQUIRED)

    # Find DLLs on Windows
    find_file(EXPAT_RUNTIME_LIBRARIES NAMES libexpat.dll expat.dll)
    if (CMAKE_CL_64)
        find_file(MSYS_RUNTIME_LIBRARIES NAMES msys-2.0.dll)
    endif()
endif()

# ============================ Set Graphviz version ============================
set(GRAPHVIZ_VERSION_MAJOR 2)
set(GRAPHVIZ_VERSION_MINOR 41)
set(GRAPHVIZ_VERSION_PATCH 0)
set(GRAPHVIZ_VERSION_STRING "${GRAPHVIZ_VERSION_MAJOR}.${GRAPHVIZ_VERSION_MINOR}.${GRAPHVIZ_VERSION_PATCH}")
configure_file(graphviz_version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/graphviz_version.h @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/graphviz_version.h DESTINATION ${HEADER_INSTALL_DIR})

# Set GRAPHVIZ_VERSION_BUILD to time of last commit, or to 0 if that fails.
execute_process(
    COMMAND           "${GIT_EXECUTABLE}" log -n 1 --format=%cd --date=format:%Y%m%d.%H%M
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    RESULT_VARIABLE   git_result
    OUTPUT_VARIABLE   GRAPHVIZ_VERSION_BUILD
    ERROR_VARIABLE    git_error
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_STRIP_TRAILING_WHITESPACE
)
if(NOT git_result EQUAL 0)
    message(WARNING "Failed to set build version: ${git_error}")
    set(GRAPHVIZ_VERSION_BUILD 0)
endif()

set(GRAPHVIZ_VERSION_FULL "${GRAPHVIZ_VERSION_MAJOR}.${GRAPHVIZ_VERSION_MINOR}.${GRAPHVIZ_VERSION_BUILD}")
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/builddate.h "#define BUILDDATE \"${GRAPHVIZ_VERSION_BUILD}\"")

message(STATUS "Graphviz version: ${GRAPHVIZ_VERSION_FULL}")

# =================== Generate config.h with proper defines ====================
# This check for getopt is used later in the build, so it is done here.
include(CheckIncludeFile)
check_include_file(getopt.h HAVE_GETOPT_H)

include(config_checks)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# ==================== Custom target for `make uninstall` ======================
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# =========================== Compiler configuration ===========================
if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    # MSVC warning C4996 mostly fires on completely valid code. The changes
    # proposed in the warning text often seriously compromise the code
    # portability, while they never substantially improve the code quality. Thus
    # we suppress this warning.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4996")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")
else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

# ============================ Packaging information ===========================
include(InstallRequiredSystemLibraries)
include(package_info)
include(CPack)

# ======================= Specify subdirectories to build ======================
add_subdirectory(windows)
add_subdirectory(lib)
add_subdirectory(plugin)
add_subdirectory(cmd)

enable_testing()
add_subdirectory(tests)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== cmd/CMakeLists.txt ===
add_subdirectory(dot)
add_subdirectory(tools)

=== lib/CMakeLists.txt ===
# No dependencies
add_subdirectory(cdt)
add_subdirectory(circogen)
add_subdirectory(common)
add_subdirectory(dotgen)
add_subdirectory(fdpgen)
add_subdirectory(ingraphs)
add_subdirectory(label)
add_subdirectory(mingle)
add_subdirectory(neatogen)
add_subdirectory(ortho)
add_subdirectory(osage)
add_subdirectory(pack)
add_subdirectory(patchwork)
add_subdirectory(pathplan)
add_subdirectory(rbtree)
add_subdirectory(sparse)
add_subdirectory(sfdpgen)
add_subdirectory(spine)
add_subdirectory(topfish)
add_subdirectory(twopigen)
add_subdirectory(vmalloc)
add_subdirectory(vpsc)
add_subdirectory(xdot)

# Dependent on: cdt
add_subdirectory(cgraph)

# Multiple dependencies
add_subdirectory(gvc)

=== tests/CMakeLists.txt ===
find_package(PythonInterp)

if (PYTHONINTERP_FOUND)
    add_subdirectory(regression_tests)
else ()
    message(WARNING "Python interperter not found, required for regression tests.")
endif ()

=== doc/dotty/Makefile ===
%.dvi: %.tex
	while [[ ! -f $@ ]] do
		latex $<
#		chkllog $(%)
	done

%.ps: %.dvi
	dvips $<.dvi

dotty.bbl:
	latex dotty.tex
	bibtex dotty
	rm dotty.dvi

all: dotty.bbl dotty.dvi

clean:
	rm -f *.aux *.log *.bbl *.blg *.ps *.dvi

=== doc/libgraph/Makefile ===
TEX=latex
PTEX=pdflatex
DVI=dvips

all : Agraph.pdf

%.pdf : %.dot
	dot -Tps2 $< | epstopdf --filter --outfile=$@

Agraph.pdf : Agraph.tex sccmap.tex agmemread.tex
	$(PTEX) Agraph.tex
	@if grep "Label(s) may have changed" Agraph.log; then $(PTEX) Agraph.tex; fi

Agraph.ps : Agraph.dvi 
	@if grep "Label(s) may have changed" Agraph.log; then $(TEX) Agraph.tex; fi
	$(DVI) -o Agraph.ps Agraph
	
TEXS = graph.tex sccmap.tex agmemread.tex

sccmap.tex : sccmap.c
	lgrind -i -c -t 4 -l C sccmap.c > sccmap.tex

agmemread.tex : agmemread.c
	lgrind -i -c -t 4 -l C agmemread.c > agmemread.tex

Agraph.aux : Agraph.tex
	$(TEX) Agraph

clean: 
	rm -rf *.bbl *.aux *.dvi *.ps *.pdf *.log *.toc *.blg

=== lib/cdt/CMakeLists.txt ===
add_definitions(-DEXPORT_CDT)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(cdt SHARED
    # Header files
    cdt.h
    dthdr.h

    # Source files
    dtclose.c
    dtdisc.c
    dtextract.c
    dtflatten.c
    dthash.c
    dtlist.c
    dtmethod.c
    dtopen.c
    dtrenew.c
    dtrestore.c
    dtsize.c
    dtstat.c
    dtstrhash.c
    dttree.c
    dtview.c
    dtwalk.c
)

# Installation location of library files
install(
    TARGETS cdt
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
    FILES cdt.h
    DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
install(
    FILES cdt.3
    DESTINATION ${MAN_INSTALL_DIR}
)

# Specify library version and soversion
set_target_properties(cdt PROPERTIES
    VERSION 5.0.0
    SOVERSION 5
)

=== lib/circogen/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GRAPHVIZ_LIB_DIR}/cdt
    ${GRAPHVIZ_LIB_DIR}/cgraph
    ${GRAPHVIZ_LIB_DIR}/common
    ${GRAPHVIZ_LIB_DIR}/gvc
    ${GRAPHVIZ_LIB_DIR}/neatogen
    ${GRAPHVIZ_LIB_DIR}/pack
    ${GRAPHVIZ_LIB_DIR}/pathplan
    ${GRAPHVIZ_LIB_DIR}/sparse
)

add_library(circogen STATIC
    # Header files
    block.h
    blockpath.h
    blocktree.h
    circo.h
    circpos.h
    circular.h
    deglist.h
    edgelist.h
    nodelist.h
    nodeset.h

    # Source files
    block.c
    blockpath.c
    blocktree.c
    circpos.c
    circular.c
    circularinit.c
    deglist.c
    edgelist.c
    nodelist.c
    nodeset.c
)

=== lib/common/CMakeLists.txt ===
BISON_TARGET(HTMLparse htmlparse.y ${CMAKE_CURRENT_BINARY_DIR}/htmlparse.c)

# Modify files generated by Bison, to match the Autotools build.
# - Replace "yy" with "aag"
# - Replace "unsigned long int" with "uint64_t"
# - Replace "unsigned long" with "uint64_t"
configure_file(
    "${TOP_SOURCE_DIR}/cmake/modify_common_htmlparse.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/modify_common_htmlparse.cmake"
    @ONLY
)
add_custom_command(
    OUTPUT ${BISON_HTMLparse_OUTPUTS}
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/modify_common_htmlparse.cmake
    APPEND
)

add_definitions(-DGVC_EXPORTS -D_BLD_gvc=1)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${TOP_SOURCE_DIR}
    ${GRAPHVIZ_LIB_DIR}/cdt
    ${GRAPHVIZ_LIB_DIR}/cgraph
    ${GRAPHVIZ_LIB_DIR}/gvc
    ${GRAPHVIZ_LIB_DIR}/label
    ${GRAPHVIZ_LIB_DIR}/pack
    ${GRAPHVIZ_LIB_DIR}/pathplan
    ${GRAPHVIZ_LIB_DIR}/fdpgen
    ${GRAPHVIZ_LIB_DIR}/xdot
)

if (WIN32)
    include_directories(${WINDOWS_DEPENDENCY_DIR}/include)
endif()

# Generate colortbl.h from sources
add_custom_command(
    OUTPUT svgcolor_lib
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/svgcolor_names ${TOP_SOURCE_DIR}/awk/svgcolor.awk
    COMMAND ${AWK_EXECUTABLE} -f ${TOP_SOURCE_DIR}/awk/svgcolor.awk
            ${CMAKE_CURRENT_SOURCE_DIR}/svgcolor_names > ${CMAKE_CURRENT_BINARY_DIR}/svgcolor_lib
)
add_custom_command(
    OUTPUT brewer_lib
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/brewer_colors ${TOP_SOURCE_DIR}/awk/brewer.awk
    COMMAND ${AWK_EXECUTABLE} -f ${TOP_SOURCE_DIR}/awk/brewer.awk
            ${CMAKE_CURRENT_SOURCE_DIR}/brewer_colors > ${CMAKE_CURRENT_BINARY_DIR}/brewer_lib
)
configure_file(
    "${TOP_SOURCE_DIR}/cmake/generate_color_lib.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/generate_color_lib.cmake"
    @ONLY
)
add_custom_command(
    OUTPUT color_lib
    DEPENDS svgcolor_lib brewer_lib ${CMAKE_CURRENT_SOURCE_DIR}/color_names
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/generate_color_lib.cmake
)
add_custom_command(
    OUTPUT colortbl.h
    DEPENDS color_lib
    COMMAND ${AWK_EXECUTABLE} -f ${TOP_SOURCE_DIR}/awk/colortbl.awk
            ${CMAKE_CURRENT_BINARY_DIR}/color_lib > ${CMAKE_CURRENT_BINARY_DIR}/colortbl.h
)

# Generate ps_font_equiv.h from sources
add_custom_command(
    OUTPUT ps_font_equiv.h
    DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/mksvgfonts.pl
        ${CMAKE_CURRENT_SOURCE_DIR}/ps_font_equiv.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/fontmap.cfg
        ${CMAKE_CURRENT_SOURCE_DIR}/ps_fontmap.txt
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/ps_fontmap.txt
                                     ${CMAKE_CURRENT_BINARY_DIR}/ps_font_equiv.h
    COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/mksvgfonts.pl
                               ${CMAKE_CURRENT_SOURCE_DIR}/fontmap.cfg
                               ${CMAKE_CURRENT_SOURCE_DIR}/ps_font_equiv.txt
                               >> ${CMAKE_CURRENT_BINARY_DIR}/ps_font_equiv.h
)

add_library(common STATIC
    # Header files
    arith.h
    color.h
    colorprocs.h
    colortbl.h
    const.h
    entities.h
    geom.h
    geomprocs.h
    globals.h
    intset.h
    htmllex.h
    htmltable.h
    logic.h
    macros.h
    memory.h
    pointset.h
    ps_font_equiv.h
    render.h
    textspan.h
    types.h
    usershape.h
    utils.h

    # Source files
    args.c
    arrows.c
    colxlate.c
    ellipse.c
    emit.c
    geom.c
    globals.c
    htmllex.c
    htmltable.c
    input.c
    intset.c
    labels.c
    ns.c
    memory.c
    output.c
    pointset.c
    postproc.c
    psusershape.c
    routespl.c
    shapes.c
    splines.c
    taper.c
    textspan.c
    timing.c
    utils.c

    # Generated files
    ${BISON_HTMLparse_OUTPUTS}
)

# Specify headers to be installed
install(
    FILES
        arith.h
        color.h
        geom.h
        textspan.h
        types.h
        usershape.h
    DESTINATION ${HEADER_INSTALL_DIR}
)

=== lib/dotgen/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GRAPHVIZ_LIB_DIR}/cdt
    ${GRAPHVIZ_LIB_DIR}/cgraph
    ${GRAPHVIZ_LIB_DIR}/common
    ${GRAPHVIZ_LIB_DIR}/gvc
    ${GRAPHVIZ_LIB_DIR}/ortho
    ${GRAPHVIZ_LIB_DIR}/pack
    ${GRAPHVIZ_LIB_DIR}/pathplan
)

add_library(dotgen STATIC
    # Header files
    aspect.h
    dot.h
    dotprocs.h

    # Source files
    aspect.c
    acyclic.c
    class1.c
    class2.c
    cluster.c
    compound.c
    conc.c
    decomp.c
    dotinit.c
    dotsplines.c
    fastgr.c
    flat.c
    mincross.c
    position.c
    rank.c
    sameport.c
)

=== lib/fdpgen/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GRAPHVIZ_LIB_DIR}/cdt
    ${GRAPHVIZ_LIB_DIR}/cgraph
    ${GRAPHVIZ_LIB_DIR}/common
    ${GRAPHVIZ_LIB_DIR}/gvc
    ${GRAPHVIZ_LIB_DIR}/neatogen
    ${GRAPHVIZ_LIB_DIR}/pack
    ${GRAPHVIZ_LIB_DIR}/pathplan
    ${GRAPHVIZ_LIB_DIR}/sparse
)

add_library(fdpgen STATIC
    # Header files
    clusteredges.h
    comp.h
    dbg.h
    fdp.h
    grid.h
    tlayout.h
    xlayout.h

    # Source files
    clusteredges.c
    comp.c
    dbg.c
    fdpinit.c
    grid.c
    layout.c
    tlayout.c
    xlayout.c
)

=== lib/ingraphs/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GRAPHVIZ_LIB_DIR}/cdt
    ${GRAPHVIZ_LIB_DIR}/cgraph
)

add_library(ingraphs STATIC
    # Header files
    ingraphs.h

    # Source files
    ingraphs.c
)

=== debian/changelog ===
graphviz (2.42.2-6ubuntu0.1) jammy; urgency=medium

  [ David Huggins-Daines ]
  * d/p/svg-scaling.patch: Fix scaling in SVG output (LP: #2015017)

 -- Dave Jones <dave.jones@canonical.com>  Sat, 11 May 2024 19:31:23 +0100

graphviz (2.42.2-6) unstable; urgency=medium

  [ Bas Couwenberg <sebastic@debian.org> ]
  * Don't build PHP extension, swig doesn't support PHP 8 yet
    (closes: #1004956).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 06 Feb 2022 19:03:12 +0100

graphviz (2.42.2-5) unstable; urgency=high

  * Fix CVE-2020-18032: out of bounds write on invalid label
    (closes: #988000).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 May 2021 11:09:59 +0200

graphviz (2.42.2-4) unstable; urgency=medium

  * Build with Guile 3.0 (closes: #885198).
  * Use AUTOPKGTEST_TMP directory for autopkgtest.
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 26 Apr 2020 05:25:24 +0000

graphviz (2.42.2-3) unstable; urgency=medium

  * Install all plugin libraries (closes: #905209).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 09 Oct 2019 16:24:32 +0000

graphviz (2.42.2-2) unstable; urgency=medium

  * Upload to Sid.
  * Update documentation link in manpages (closes: #710377).

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Multiarchify packages (closes: #941143).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 05 Oct 2019 22:04:01 +0000

graphviz (2.42.2-1) experimental; urgency=medium

  * New upstream release.
  * Update patches.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 23 Sep 2019 16:09:12 +0000

graphviz (2.42.1-1) experimental; urgency=medium

  * New major upstream release.
  * Update patches.
  * Remove Python 2 bindings (closes: #936653).
  * Update Python packaging bits.
  * Enable WebP output format plugin.
  * Update Lintian overrides.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 01 Sep 2019 11:07:19 +0000

graphviz (2.40.1-7) unstable; urgency=medium

  * Build with ipsep mode (closes: #595084).

  [ Igor S. <grok0@gmx.com> ]
  * Fix libann detection.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 13 Jul 2019 14:19:42 +0000

graphviz (2.40.1-6) unstable; urgency=high

  * Fix CVE-2018-10196: NULL pointer dereference in rebuild_vlists()
    (closes: #898841).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 08 Apr 2019 15:51:00 +0000

graphviz (2.40.1-5) unstable; urgency=medium

  * Patch upstream _gv.so symlink creation (closes: #905209).
  * Tighten libgvc6 version dependency (closes: #895590).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 03 Oct 2018 15:04:59 +0000

graphviz (2.40.1-4) unstable; urgency=medium

  * Build with libRSVG (closes: #827675).
  * Update Standards-Version to 4.2.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 11 Sep 2018 15:17:23 +0000

graphviz (2.40.1-3) unstable; urgency=medium

  * Correct libgvc6 config file deletion on package removal (closes: #894632).
  * Backport security related patches:
    - fix memory leaks,
    - avoid integer overflow problem.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 02 Apr 2018 17:22:54 +0000

=== debian/control ===
Source: graphviz
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Standards-Version: 4.5.0
Build-Depends: tk-dev,
 tcl-dev,
 debhelper-compat (= 11),
 dh-python,
 libfreetype6-dev,
 zlib1g-dev,
 libjpeg-dev,
 libpng-dev,
 libxaw7-dev,
 bison,
 flex,
 libexpat1-dev,
 libfontconfig1-dev,
 swig,
 libperl-dev,
 libgd-dev (>= 2.0.33),
 guile-3.0-dev,
 groff-base,
 ghostscript,
 lua5.2,
 liblua5.2-dev,
 ruby,
 ruby-dev (>= 1:2.2),
 libargon2-dev,
 libsodium-dev,
 libxml2-dev,
 python3-dev,
 libcairo2-dev,
 libpango1.0-dev,
 d-shlibs,
 chrpath,
 libgtk2.0-dev,
 libgts-dev,
 libann-dev,
 librsvg2-dev,
 libwebp-dev
Build-Conflicts: tcl8.3, tcl8.4, tcl8.5
Homepage: https://www.graphviz.org/

Package: graphviz
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, libgvc6 (>= 2.42.1), ${misc:Depends}
Recommends: fonts-liberation
Suggests: gsfonts, graphviz-doc
Description: rich set of graph drawing tools
 Graph drawing addresses the problem of visualizing structural information
 by constructing geometric representations of abstract graphs and networks.
 Automatic generation of graph drawings has important applications in key
 technologies such as database design, software engineering, VLSI and
 network design and visual interfaces in other domains. Situations where
 these tools might be particularly useful include:
 .
   * you would like to restructure a program and first need to understand
     the relationships between its types, procedures, and source files
   * you need to find the bottlenecks in an Internet backbone - not only
     individual links, but their relationships
   * you're debugging a protocol or microarchitecture represented as a
     finite state machine and need to figure out how a certain
     error state arises
   * you would like to browse a database schema, knowledge base, or
     distributed program represented graphically
   * you would like to see an overview of a collection of linked documents
   * you would like to discover patterns and communities of interest in a
     database of telephone calls or e-mail messages
 .
 This package contains the command-line tools.

Package: libgv-guile
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Guile bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the guile (3.0) bindings.

Package: libgv-lua
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lua bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the lua5.2 bindings.

Package: libgv-perl
Architecture: any
Multi-Arch: same
Section: perl
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Perl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Perl bindings.

Package: python3-gv
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
Breaks: libgv-python (<< 2.40.1-0~)
Replaces: libgv-python (<< 2.40.1-0~)
Description: Python3 bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Python3 bindings.

Package: libgv-ruby
Architecture: any
Multi-Arch: same
Section: ruby
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Ruby bindings.


Package: libgv-tcl
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tcl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Tcl (8.6) bindings.

Package: libcgraph6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cgraph library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cgraph library.

Package: libcdt5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cdt library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cdt library.

Package: libpathplan4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - pathplan library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the pathplan library.

Package: libgvc6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libgv-php5
Replaces: libgv-php5
Description: rich set of graph drawing tools - gvc library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the gvc library.

Package: libgvc6-plugins-gtk
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - gtk plugins
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the gtk and gdk-pixbuf plugins.

Package: libgvpr2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgvpr1
Description: rich set of graph drawing tools - gvpr library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the gvpr library.

Package: libxdot4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - xdot library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the xdot library.

Package: liblab-gamut1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - liblab_gamut library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the liblab_gamut library.

Package: libgraphviz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcdt5 (= ${binary:Version}),
 libcgraph6 (= ${binary:Version}),
 libgvc6 (= ${binary:Version}),
 libgvpr2 (= ${binary:Version}),
 libpathplan4 (= ${binary:Version}),
 libxdot4 (= ${binary:Version}),
 liblab-gamut1 (= ${binary:Version}),
 libgvc6-plugins-gtk (= ${binary:Version}),
 ${devlibs:Depends}, ${misc:Depends}
Replaces: libgraphviz3-dev, libgraphviz4-dev (<< 2.16-3)
Provides: graphviz-dev
Description: graphviz libs and headers against which to build applications
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: graphviz-doc
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: doc
Suggests: graphviz
Description: additional documentation for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs HTML and PDF documentation for Graphviz, as well as
 examples.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

AUTOGENERATED = libgvc6.postrm

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIGURE_LIBS    = LIBS="-Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed"
endif

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel mips))
DEB_CFLAGS_MAINT_APPEND += "-fno-ipa-sra"
endif

PYTHON_VERSIONS  = $(shell pyversions -r)
PYTHON3_VERSIONS = $(shell py3versions -r)

# sonames for various libraries
SO_CGRAPH	= 6
SO_CDT		= 5
SO_GVC		= 6
SO_PATHPLAN	= 4
SO_XDOT		= 4
SO_GVPR		= 2
SO_LAB-GAMUT	= 1

override_dh_clean:
	dh_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -f $(CURDIR)/tclpkg/gv/*.pdf $(CURDIR)/cmd/dot/*.pdf
	rm -f $(CURDIR)/configure $(CURDIR)/version.m4
	find $(CURDIR) -name Makefile.in -delete

override_dh_autoreconf:
	$(CURDIR)/autogen.sh NOCONFIG
	dh_autoreconf

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@TRIPLET@%${DEB_HOST_MULTIARCH}%g' \
			< debian/$$f.in \
			> debian/$$f ; \
	done
	dh_auto_configure -- \
	--disable-silent-rules \
	--prefix=/usr \
	--datadir=\$${prefix}/share \
	--infodir=\$${prefix}/share/info \
	--mandir=\$${prefix}/share/man \
	--disable-static \
	--without-included-ltdl \
	--with-pangocairo \
	--with-x \
	--with-gdk-pixbuf \
	--without-glut \
	--with-gnomeui \
	--with-gtk \
	--without-poppler \
	--with-gts \
	--with-ipsepcola \
	--without-qt \
	--with-rsvg \
	--with-ann \
	--with-webp \
	--disable-go \
	--enable-guile \
	--enable-lua \
	--disable-php \
	--enable-ruby \
	--enable-tcl \
	--disable-java \
	--disable-ocaml \
	--disable-r \
	--disable-sharp \
	--disable-python2 \
	--enable-python3 \
	$(CONFIGURE_LIBS) \
	$(shell $(dpkg_buildflags) --export=configure)

override_dh_auto_test:
	echo Self tests are buggy

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp/ -name \*.la -delete
	# Duplicate library
#	rm $(CURDIR)/debian/tmp/usr/lib/tcl*/graphviz/libgv_tcl.so

override_dh_install-arch:
	dh_install --arch
	mv $(CURDIR)/debian/libgvc$(SO_GVC)/usr/sbin/dot \
		$(CURDIR)/debian/libgvc$(SO_GVC)/usr/sbin/libgvc$(SO_GVC)-config-update
	# Symlink dot due to #868546 (debug packages conflict)
	rm $(CURDIR)/debian/graphviz/usr/bin/dot
	ln -s /usr/sbin/libgvc$(SO_GVC)-config-update \
		$(CURDIR)/debian/graphviz/usr/bin/dot
	# NFU
	rm -rf $(CURDIR)/debian/tmp/usr/lib64/

override_dh_install-indep:
	dh_install --indep
	# Remove duplicate changelog
	rm -f $(CURDIR)/debian/graphviz-doc/usr/share/doc/graphviz/ChangeLog

%:
	dh $@ --with python3

.PHONY: override_dh_clean override_dh_autoreconf override_dh_auto_configure \
	override_dh_auto_test override_dh_auto_install \
	override_dh_install-arch override_dh_install-indep
